{ ... }@args:

with builtins;

let
  fix = f: let x = f x; in x;

  readTree = import ./nix/readtree.nix {};

  # Tracking nixos-unstable as of 2021-01-31.
  nixpkgsCommit = "44ad80ab1036c5cc83ada4bfa451dac9939f2a10";
  nixpkgsSrc = fetchTarball {
    url = "https://github.com/NixOS/nixpkgs/archive/${nixpkgsCommit}.tar.gz";
    sha256 = "1b61nzvy0d46cspy07szkc0rggacxiqg9v1py27pkqpj7rvawfsk";
  };
  nixpkgs = import nixpkgsSrc {
    config.allowUnfree = true;
    config.allowBroken = true;
  };

in fix (self: rec {
  config = {
    hscloud = self // {
      root = ./.;
    };
    pkgs = nixpkgs;
    pkgsSrc = nixpkgsSrc;

    inherit (nixpkgs) lib stdenv;
  };

  bgpwtf = readTree config ./bgpwtf;
  cluster = readTree config ./cluster;
  hswaw = readTree config ./hswaw;
  ops = readTree config ./ops;

  pkgs = nixpkgs;
})
